#-----------------------------------------------------------------------------
# Image Sequence Background
#-----------------------------------------------------------------------------
# 3/21/06 by Ockham (David G. Drumright)
#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import poser
import os
import string
import glob
scene = poser.Scene()

global Files
Files=[]

#-----------------------------------------------------------------------------
BasePathUncut = poser.AppLocation()
BasePath = BasePathUncut[:(-len("poser.exe"))]
#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Image sequence in background")

        self.StatusEntry = Entry(self.master,width=60)
        self.StatusEntry.grid(row=0,column=0,columnspan=3)

        # Go/nogo buttons.
        self.buttonName = Button(self.master, text="Get background", command=self.HandleName)
        self.buttonName.grid(row=3, column=0)

        self.buttonGo = Button(self.master, text="Make animation", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=1)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)
        self.StatusEntry.insert(0,'Pick one member of the sequence')


    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleName(self):
        # Pop up file box to get name.
        global Files
        BasePathUncut=poser.AppLocation()
        BasePath=BasePathUncut[:(-len('poser.exe'))]
        MyPath=os.path.normpath(BasePath+'/runtime/*.BMP')
        fn=tkFileDialog.askopenfilename(initialfile=MyPath, defaultextension=[("Background file", "*.BMP *.bmp")] )

        if not fn:
            self.ShowStatus("No files selected. Try again.")
            return 0

        self.ShowStatus("Locating the sequence....")
        CurDrive,MainName=os.path.split(fn)
        BaseName,ext = os.path.splitext(MainName)
        # Separate the number
        Parts=string.split(BaseName,"_")
        if Parts and (len(Parts)>1):
            BaseName=Parts[0]
        print BaseName
        RawFiles=os.listdir(CurDrive)
        Files=[]
        for RF in RawFiles:
            if string.count(RF,BaseName):
                Files.append(os.path.normpath(os.path.join(CurDrive,RF)))

        if not Files:
            self.ShowStatus("Can't find others for some reason.")
            return

        Files.sort()
        self.ShowStatus("Now hit 'Make Animation'")

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        # Locate all files with same base as original.
        # If count doesn't agree with frames, give message.
        if len(Files)<1:
            self.ShowStatus("Must select background files first.")
            return

        # Get the output name
        self.ShowStatus("Give a base name for output.")
        BasePathUncut=poser.AppLocation()
        BasePath=BasePathUncut[:(-len('poser.exe'))]
        MyPath=os.path.normpath(BasePath+'/runtime/*.BMP')
        OutName=tkFileDialog.asksaveasfilename(initialfile=MyPath, defaultextension=[("Output name", "*.BMP *.bmp")] )
        OutBase,ext=os.path.splitext(OutName)

        # Now run the frames.
        for n in range(scene.NumFrames()):
            self.ShowStatus("rendering frame %d" % n)
            scene.SetFrame(n)
            try:
                OneFile=Files[n]
            except:
                break
            scene.SetBackgroundImage(OneFile)
            scene.Render()
            TryName='%s_%.4d.BMP' % (OutBase,n)
            scene.SaveImage("bmp",TryName)
        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
